/* This plugin adds two admin commands that should deter cheating in CS. It 
 * takes the original code by KaReL and [fah-q] Dio and impliments it as a plugin.
 *
 * New Commands:
 *	admin_bury 	- Plants target in the ground, makes him glow green, 
 * 			  and drop all his goods.
 *	admin_unbury    - Un-plants the target after a bury.
 *
 * 2.50.1 7/31/01
 *      admin_bury_time - Gets/Sets the time in seconds the player should glow 
 *                        after a bury. This does not affect the actual bury.
 *
 * [fah-q] Dio
 */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_BURY ACCESS_KICK

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.1";

//2.50.1 7/31/01
new BURY_GLOWTIME = 60;

public admin_bury(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new bury_user[MAX_DATA_LENGTH];
	new Reason[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new x, y, z;

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data,bury_user,Reason,MAX_DATA_LENGTH);
	if ( check_user(bury_user) == 1) {
		new real_user[MAX_NAME_LENGTH];
		get_username(bury_user,real_user,MAX_NAME_LENGTH);
		say_command(User,Command,real_user);
		if(check_immunity(real_user)!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't bury %s, you silly bear.", real_user);
			say(Text);
		} else {
			snprintf(Text, MAX_TEXT_LENGTH, "%s has broke the rules! Search and Destroy!", real_user);
			say(Text);
            		
            		messageex(real_user, "Please obey our rules!", print_chat); 
            		
			if (strlen(Reason) != 0) {
				snprintf(Text, MAX_TEXT_LENGTH, "You have been buried because %s", Reason);
				messageex(real_user, Text, print_chat);
			}

		        execclient(real_user, "slot1"); // drop his first weapon
		        execclient(real_user, "+attack");
		        execclient(real_user, "-attack");
		        execclient(real_user, "drop");
		
		        execclient(real_user, "slot2"); // drop his pistol (if any)
		        execclient(real_user, "+attack");
		        execclient(real_user, "-attack");
		        execclient(real_user, "drop");
		
		        execclient(real_user, "slot5"); // drop the bomb (if any)
		        execclient(real_user, "+attack");
		        execclient(real_user, "-attack");
		        execclient(real_user, "drop");
					
			glow(real_user, 0, 255, 0);
            		
            		get_userorigin(real_user, x, y, z);
            		teleport(real_user, x, y, (z-20));			
			
			// 2.50.1 7/31/01
       			set_timer("bury_noglow",BURY_GLOWTIME,1,real_user);

		}
	} else {
		selfmessage("Unrecognized player: ");
		selfmessage(bury_user);
	}
	return PLUGIN_HANDLED;
}

public admin_unbury(HLCommand,HLData,HLUserName,UserIndex) {
  	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new bury_user[MAX_DATA_LENGTH];
	new PMsg[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new x, y, z;

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data,bury_user,PMsg,MAX_DATA_LENGTH);	
	if ( check_user(bury_user) == 1) {
		new real_user[MAX_NAME_LENGTH];
		get_username(bury_user,real_user,MAX_NAME_LENGTH);
		
		say_command(User,Command,real_user);
		
		snprintf(Text, MAX_TEXT_LENGTH, "%s has been restored to honour!", real_user);
		say(Text);
            		
		if (strlen(PMsg) != 0) {	
			messageex(real_user, PMsg, print_chat);
		} else {
		  	messageex(real_user, "Play nice now!", print_chat); 
		}
		
           	execclient(real_user, "say I'm free ... I'm free!");
           		
 		get_userorigin(real_user, x, y, z);
            	teleport(real_user, x, y, (z+30));
 		
 		glow(real_user, 0, 0, 0); 		          		
 	}
 	return PLUGIN_HANDLED; 	
} 
         	
public admin_bury_time(HLCommand,HLData,HLUserName,UserIndex) {

	new User[MAX_NAME_LENGTH];
	new Data[MAX_TEXT_LENGTH];
	new Command[MAX_TEXT_LENGTH];

	new strMessage[MAX_TEXT_LENGTH];
	
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
  	  
	if (strlen(Data) > 0) {
		BURY_GLOWTIME = strtonum(Data);
		set_vaultdata("BURY_GLOWTIME", Data);
	}
	
	snprintf(strMessage, MAX_TEXT_LENGTH, "[ADMIN] Bury Glow Time Is %d seconds", BURY_GLOWTIME);
	selfmessage(strMessage);	

	log_command(User, Command, Data);
	
	return PLUGIN_HANDLED;
}

// 2.50.1 7/31/01
public bury_noglow(Timer,Repeat,HLName,HLParam) {
	new strName[MAX_NAME_LENGTH];
  
	convert_string(HLParam,strName,MAX_NAME_LENGTH);

 	glow(strName, 0, 0, 0); 		          		
 
 	return PLUGIN_HANDLED;   
}

public plugin_init() {
	plugin_registerinfo("Dio's Admin Plugin","Dio's Counter Strike Bury commands.",STRING_VERSION);
	
	plugin_registercmd("admin_bury","admin_bury",ACCESS_BURY,"admin_bury <target or WONID or IP> [Reason]: Plants target in the ground and make him drop all his goods.");
	plugin_registercmd("admin_unbury","admin_unbury",ACCESS_BURY,"admin_unbury <target or WONID or IP> [Message]: Un-plants target.");

	// 2.50.1 7/31/01
	plugin_registercmd("admin_bury_time", "admin_bury_time", ACCESS_BURY,"admin_bury_time <seconds>: Set the time the buried player should glow for.");

	// 2.50.1 7/31/01
	new VaultData[MAX_DATA_LENGTH];	

	if(get_vaultdata("BURY_GLOWTIME", VaultData, MAX_DATA_LENGTH) != 0) {
		BURY_GLOWTIME = strtonum(VaultData);
	} else {
		BURY_GLOWTIME = 60;
		set_vaultdata("BURY_GLOWTIME", "60");
	}

	return PLUGIN_CONTINUE;
}
